#include <iostream>
#include "../util/Stack.h"
#include "tree.h"
using namespace std;

void visit(node* t)
{
    cout << ' ' << t->info << ' ';
}

void traversePreorder(node *t)
{
    Stack<node*> stack(50);
    stack.push(t);
    while (!stack.empty())
    {
        t = stack.pop(); visit(t);
        if (t->r != s_z) stack.push(t->r); 
        if (t->l != s_z) stack.push(t->l); 
    }
    cout << endl;
}

void traversePostorder(node *t)
{
	Stack<node*> stack(50);
	do 
	{
		if (t->l != s_z) 
		{
			stack.push(t);
			stack.push(s_z);
			if (t->r != s_z) stack.push(t->r);
			t = t->l;
		}
		if ((t->l == s_z) && (t != s_z)) 
		{
			if (t->r == s_z)
			{
				visit(t);
				t = stack.pop();
			} 
		}
		if (t == s_z) 
		{
			visit(stack.pop());
			if (!stack.empty()) t = stack.pop();
		}
	} while (!stack.empty()); 
	         

	cout << endl;
}

int main(int, char**)
{
    try
    {
	//traversePreorder(buildTree());
	traversePostorder(buildTree());
    }
    catch(exception &e)
    {
	cerr << "Error: " << e.what() << endl;
    }
}
