#ifndef _STACKLINKEDLISTARRAY_H
#define _STACKLINKEDLISTARRAY_H

#include <stdexcept>

template<class itemType> 
class Stack
{
public:
	Stack(int max = 100)
    	{
		m_key = new itemType[max];
		m_next = new int[max];

		head = 0; 
		tail = 1;
		inc  = 2;
		
		m_next[head] = tail;
		m_next[tail] = tail;
	}

    	~Stack()
    	{
		delete m_key;
		delete m_next;
    	}

    	void push(itemType val)
    	{
		m_key[inc] = val;
		m_next[head] = inc;
		inc++;
    	}

    	itemType pop()
    	{
		if (isEmpty())
			throw std::underflow_error("Pop from an empty stack.");

		m_next[head] = m_next[head] - 1;
		inc--;
		return m_key[inc];
    	}

    	int isEmpty()
    	{ 
		return m_next[head] == m_next[tail];
	}

private:
	itemType *m_key;
	int *m_next; 
	int head, tail, inc;
};

#endif

