#ifndef _STACK_H
#define _STACK_H
#include <stdexcept>

template<class itemType> class Stack
{
public:
    Stack(int max)
    {
	head = new node; z = new node;
	head->next = z;  z->next = z;
    }

    ~Stack()
    { 
	struct node *t = head;
	while (t != z) 
	{ head = t; t = t->next; delete head; }
    }

    void push(itemType v)
    {
	struct node *t = new node;
	t->key = v; t->next = head->next; 
	head->next = t;
    }

    itemType pop()
    {
	itemType x;
	struct node *t = head->next;
	if (t == z)
	    throw std::underflow_error("Pop from an empty stack.");
	head->next = t->next; x = t->key;
	delete t; return x;
    }

    int empty()
    { return head->next == z; }

private:
    struct node 
    { itemType key; struct node *next; };
    struct node *head, *z;
};

#endif

// Local Variables: 
// mode: c++
// End: 
